html {
  height: 100%;
  overflow-y: auto;
}

body {
  margin: 0;
  height: 100%;
  overflow-y: auto;
}

#app {
  height: 100%;
  overflow-y: auto;
}

#app-header {
  width: 100%;
  position: sticky;
  top: 0;
  z-index: 99;
}

#app-footer {
  width: 100%;
  z-index: 99;
  height: @footerHeight;
  background-color: @blue;
  color: white;
  font-size: 0.7em;
  span {
    line-height: @footerHeight;
    text-align: center;
  }
}

.page {
  min-height: calc(100vh - @headerHeight - @footerHeight - 1em);
  // position: relative;
  top: @headerHeight;
  margin: 1em auto 0;
  padding-bottom: 5em;
  width: 100%;
  max-width: 1500px;
  display: flex;
  flex-direction: column;
  .back-link {
    cursor: pointer;
    color: @blue;
    padding: 1em 1.5em;
    width: max-content;
    span {
      line-height: 1.3em;
      vertical-align: text-bottom;
    }
  }
  .back-link:hover {
    font-weight: bold;
  }
}
.spinner-border {
  opacity: 0.7;
  width: 1.3rem;
  height: 1.3rem;
  border-width: 2px;
}

.b-overlay-wrap .position-absolute {
    height: auto !important;
}

input[type=date]::-webkit-calendar-picker-indicator {
  cursor: pointer !important;
}

@media screen and (max-width: 1200px) {
  #app {
    overflow-x: auto;
  }
  .page {
    min-width: 1000px !important;
  }
  .items-col {
    min-width: 500px;
  }
  .demandes-col, .dashboard-col {
    min-width: 300px;
  }
}

.accounts-page, .data-page {
  display: flex;
  justify-content: space-around;
  margin-top: 4rem;
  height: calc(100% - @footerHeight - 4rem);
}

.items-col {
  max-width: 600px;
  height: calc(100% - @footerHeight - 4rem);
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  justify-content: space-between;
  .element {
    display: flex;
    flex-flow: column nowrap;
    align-items: flex-start;
    width: 100%;
  }
}

.demandes-row {
  justify-content: center;
}

.demandes-col {
  margin-top: 0.5rem;
  height: fit-content;
  max-height: calc(50% - 0.5rem);
  overflow-y: scroll;
  max-width: 500px;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}
.dashboard-col {
  max-width: 500px;
}
.data-col {
  max-width: 600px;
  height: calc(100% - @footerHeight - 4rem);
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  .element {
    display: flex;
    flex-flow: column nowrap;
    align-items: flex-start;
    width: 100%;
    // margin: 0 0 2rem 25%;
  }
}

.not-found {
  display: flex;
  align-items: center;
  justify-content: center;
  h1 {
    color: @blue;
    font-size: 5em;
  }
  p {
    color: @blue;
    font-size: 1.5em;
  }
  .btn {
    margin-top: 2em;
    .b-icon {
      margin-right: 0.5em;
    }
  }
}

.line-header {
  color: @blue;
  line-height: 1.5;
  margin-top: 2em;
  overflow-x: hidden;
  img {
    width: 1.2em;
    height: 1.2em;
    padding-bottom: 0.15em;
  }
}

.line-header:after {
  content:"";
  display: inline-block;
  vertical-align: baseline;
  width: 100%;
  margin-right: -100%;
  margin-left: 10px;
  border-top: 1px solid @blue !important;
}

.add-btn {
  cursor: pointer;
  width:max-content;
  padding: 0.5em;
  margin: 0.6em 1em;
  box-shadow: 0 0 2px 1px @lightBlue;
  color: @blue;
  font-size: 1.2em;
  font-weight: bold;
  border: 2px solid @lightBlue;
  border-radius: 5px;
}

.add-btn:hover {
  background: @blue;
  border: 2px solid @lightBlue;
  box-shadow: none;
  color: white;
}

.top {
  margin: 0 1em;
  .left-col {
    span {
      margin-left: 0.5em;
      font-size: 2em;
      img {
        width: 1.5em;
        height: 1.5em;
        padding-bottom: 0.25em;
        filter: invert(100%) brightness(0%) contrast(100%);
      }
    }
  }
  .right-col {
    display: flex;
    justify-content: flex-end;
    align-items: flex-end;
    margin-right: 2em;
  }
}

// Table
table:not(.data-dashboard) {
  table-layout: fixed;
  width: calc(100% - 3em);
  white-space: nowrap;
  margin: 0 1em 1em;
  border: 1px groove #ffffff;
  border-collapse: collapse;
  color: #212529;
  thead {
    color: white;
    background-color: #343a40;
    tr {
      th {
        cursor: pointer;
        padding: 0.4rem;
        padding-right: calc(0.75rem + 0.65em);
        border-bottom-width: 2px;
        border-color: #454d55;
        font-size: 0.8em;
        text-overflow: ellipsis;
        white-space: nowrap;
        overflow: hidden;
        .cell-header {
          display: flex;
          flex-wrap: nowrap;
          justify-content: flex-start;
          align-items: center;
          width: 100%;
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
          .sort-field {
            display: flex;
            flex-direction: column;
            max-width: min-content;
            margin-left: 1vw;
            // svg.b-icon:hover {
            //   filter: brightness(0) saturate(100%) invert(60%) sepia(51%) saturate(4093%) hue-rotate(182deg) brightness(102%) contrast(101%);
            // }
            svg.b-icon.active {
              filter: brightness(0) saturate(100%) invert(60%) sepia(51%) saturate(4093%) hue-rotate(182deg) brightness(102%) contrast(101%);
            }
            svg.b-icon.disabled {
              opacity: 0.1;
            }
          }
        }
      }
      .check-cell {
        border: none;
        .form-check {
          position: relative;
          margin: 0.2rem 0 0 0;
        }
      }
    }
  }
  tbody {
    tr {
      cursor: pointer;
      border: 1px groove #ffffff;
      td {
        padding: 0.4rem;
        padding-right: calc(0.75rem + 0.65em);
        font-size: 0.8em;
        font-weight: 500;
        min-height: 30px;
        width: 100%;
        text-overflow: ellipsis;
        white-space: nowrap;
        overflow: hidden;
        img {
          height: 1.3em;
        }
        div {
          text-overflow: ellipsis;
          white-space: nowrap;
          overflow: hidden;
        }
      }
      td:nth-of-type(1) {
        font-weight: bold;
      }
      .check-cell {
        border: none;
        .form-check {
          position: relative;
          margin: 0;
        }
      }
    }
    tr:nth-child(2n) {
      background-color: rgba(238, 238, 238, 0.7);
    }
    tr:hover {
      background-color: #187bc644;
    }
    td:last-child {
      padding: 0.20rem;
      padding-right: calc(0.40rem + 0.65em);
      img:hover {
        height: 1.6em;
      }
      img.disabled {
        filter: brightness(0) saturate(100%) invert(70%) sepia(0%) saturate(9%) hue-rotate(145deg) brightness(95%) contrast(84%);
      }
      img.disabled:hover {
        height: 1.3em;
      }
    }
  }
}
.data-dashboard {
  width: 100%;
  min-width: 400px;
  max-width: 500px;
  margin: 0 0 1em;
  thead {
    background-color: #575757;
    color: white;
    tr {
      height: 1rem;
      font-size: 1rem;
      line-height: 1rem;
    }
  }
  tbody {
    tr {
      height: 1rem;
      font-size: 0.9rem;
      line-height: 1rem;
      td {
        padding: 0.1rem 0.5rem;
        vertical-align: middle;
      }
    }
  }
}

.custom-table {
  margin: 1em 1em;
}

.filters-col {
  margin-top: 3.55em;
  margin-left: -3em;

  .btn.active {
    border-radius: 0 !important;
  }
  .btn {
    box-shadow: none !important;
  }
  .btn:hover {
    background-color: @lightBlue;
  }
}

.users-table {
  table {
    width: calc(100% - 1em)
  }
}

.resources-table {
  margin-left: 1em;
  table {
    width: calc(100% - 2em)
  }
}

.pagination {
  .page-item {
    .page-link {
      border: none;
      font-weight: 400;
      color: @blue;
    }
  }
  .page-item.active {
    .page-link {
      color: @blue;
      background-color: transparent;
      font-weight: bolder;
      font-size: 1.2em;
      text-shadow: 0 0 2px @blue;
      padding: 0.325em 0.75em;
      pointer-events: none;
    }
  }
  .page-item.disabled {
    .page-link {
      opacity: 0.5;
    }
  }
}

// Search bar
.search-bar {
  margin-left: 1em;
  margin-top: 1.5em;
}

.search-table {
  display: block;
  width: 100%;
  height: calc(1.5em + 0.75rem + 2px);
  font-weight: 400;
  line-height: 1.5;
  color: #495057;
  background-color: #fff;
  background-clip: padding-box;
  border: 1px solid #ced4da;
  border-radius: 0.25rem;
  transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
  font-size: 1em;
  background-image: url('../assets/icons/search_lens.svg');
  background-position: 10px 5px; 
  background-repeat: no-repeat;
  background-size: 1.5em 1.5em;
  padding: 0.375rem 0.75rem 0.375rem 3em;
}
.search-table:focus {
  outline-width: 0;
  box-shadow: 0 0 2px 2px @blue;
}

// Forms
input.form-control {
  height: 2.45rem;
}
input.form-control.empty {
  color:rgb(184, 186, 190) !important;
}
form {
  margin: 1em 1em 1em;
  .form-row {
    padding-left: 1em;
    p:not(.card-text) {
      width: 100%;
      color: grey;
      font-style: italic;
      font-size: 0.7em;
      margin-bottom: 0.2em;
    }
    .form-group {
      input {
        font-size: 0.9em;
        color: rgb(29, 29, 29);
        font-weight: 400;
        border-width: 2px;
      }
      input::placeholder {
        color: rgb(192, 192, 192);
      }
      textarea {
        border-width: 2px;
      }
      textarea::placeholder {
        color: rgb(192, 192, 192);
      }
    }
    .form-group.disabled {
      opacity: 0.4;
      pointer-events: none;
    }
  }
  .form-row.disabled {
    opacity: 0.4;
    pointer-events: none;
  }
  .user-organisation {
    margin: auto 0 auto 1em;
  }
}
form.disabled {
  opacity: 0.4;
  pointer-events: none;
}

.add-button {
  width: calc(100% - 0.65em);
  margin-left: 0.65em;
  background-color: white;
  color: @blue;
  font-size: 1.4em;
  border: solid 1px @lightBlue;
  border-radius: 4px;
  box-shadow: 0 0 5px #645d5d1a;
  padding: 0.2em 0;
}
.add-button:hover:not(.disabled) {
  // font-weight: 500;
  box-shadow: 0 0 5px 1px @lightBlue;
}
.add-button.disabled {
  pointer-events: none;
  opacity: 0.5;
}

.form-footer {
  margin: 3em 0 3em 1em;
  padding: 0 3px 3px 3px;
  display: flex;
  justify-content: space-between;
  button.btn-primary {
    margin-left: 1em;
    font-size: 1.4em;
    border: 2px solid #9BD0FF;
    border-radius: 8px;
  }
  button.btn-danger {
    font-size: 1.4em;
    border: 2px solid #ff9b9b;
    border-radius: 8px;
  }
  button.btn-outline-secondary {
    font-size: 1.4em;
    background-color: #F7F8FA;
    border: 2px solid #A9B2B9;
    border-radius: 8px;
    color: #2F3234;
  }
  button.btn-outline-secondary:hover {
    color: white;
    background-color: #4b4b4b;
  }
  .btn-group-vertical {
    .btn {
      border-radius: 8px !important;
    }
  }
}

.form-errors {
  color: #EB0600 !important;
  float: right;
}

.form-check {
  margin: 1em 0 1.5em;
  input {
    cursor: pointer;
  }
  .form-check-label {
    margin-left: 0.5em;
  }
}

label {
  font-size: 0.8em;
  font-weight: bold;
  margin-bottom: 0.1em; 
}

label.required:after {
	content: ' *';
	color: rgb(209, 0, 0);
}

.control {
  width: 100%;
  .form-errors {
    display: block;
    font-size: 0.8em;
    font-style: italic;
  }
}
.control.is-invalid {
  .form-errors {
    color: #EB0600 !important;
  }
  input {
    border: 1px #EB0600 solid;
  }
}
.control.is-valid {
  .form-errors {
    color: #078b40;
  }
  input {
    border: 1px #078b40 solid;
  }
}

.alert {
  margin-left: 1em;
  .btn-close {
    float: right;
  }
}

// Cards
.card-container {
  position: relative;
  // top: 10%;
  margin: 2em auto;
  padding: 3em 2em 2em;
  width: 80%;
  height: fit-content;
  background-color: rgb(239, 241, 245);
  box-shadow: 0 0 5px rgb(184, 186, 190);
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  text-overflow: ellipsis;
  // white-space:pre-line;
  overflow: hidden;
  h2 {
    color: @blue;
    img {
      height: 1.5em;
    }
  }
  h5 {
    margin: 1.5rem 0 0;
    text-align: center;
    word-break: keep-all;
  }
  .codename {
    font-size: 0.8em;
    word-break: break-all;
    text-align: center;
  }
  .card-thumbnail {
    width: 80%;
  }
  #user-connexions, #user-publications {
    display: flex;
    flex-direction: column;
    align-items: center;
    h2 {
      margin-bottom: 0;
    }
  }
}

.side-footer {
  margin: 3em auto 2em;
  width: 80%;
  display: flex;
  flex-flow: wrap;
  justify-content: space-between;
  font-size: 1em;
  button {
    margin-bottom: 1em;
  }
  button.btn-primary {
    border: 2px solid #9BD0FF;
    border-radius: 8px;
  }
  button.btn-danger {
    border: 2px solid #ff9b9b;
    border-radius: 8px;
  }
  button.btn-outline-secondary {
    background-color: #F7F8FA;
    border: 2px solid #A9B2B9;
    border-radius: 8px;
    color: #2F3234;
  }
  button.btn-outline-secondary:hover {
    color: white;
    background-color: #4b4b4b;
  }
  .btn-group-vertical {
    .btn {
      border-radius: 8px !important;
    }
  }
}

.access-permissions {
  // position: sticky;
  // top: 50%;
  margin: 0 auto;
  .btn {
    font-weight: 500;
    font-size: 1.2em;
    background-color: #F7F8FA;
    border: 2px solid #A9B2B9;
    border-radius: 8px;
    color: #2F3234;
    img {
      height: 1.2em;
      margin-bottom: 0.3em;
      filter: brightness(0) saturate(100%) invert(44%) sepia(8%) saturate(483%) hue-rotate(167deg) brightness(100%) contrast(91%);
      -webkit-filter: brightness(0) saturate(100%) invert(44%) sepia(8%) saturate(483%) hue-rotate(167deg) brightness(100%) contrast(91%);
      -moz-filter: brightness(0) saturate(100%) invert(44%) sepia(8%) saturate(483%) hue-rotate(167deg) brightness(100%) contrast(91%);
    }
  }
  .btn:hover {
    color: white;
    background-color: #4b4b4b;
    img {
      filter: brightness(0%) invert(100%);
      -webkit-filter: brightness(0%) invert(100%);
      -moz-filter: brightness(0%) invert(100%);
    }
  }
}

// Modals
.modal-title {
  color: @blue;
  font-size: 1.7em;
}

.sucess-message {
  margin-top: 1em;
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  h3 {
    color: #228539;
  }
}

.failed-message {
  margin-top: 1em;
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  h3 {
    color: #ad1e1e;
  }
}

// Multiselect
.multiselect__tags {
  border: 2px solid #ced4da;
  .multiselect__input {
    border: none !important;
    font-size: 1rem !important;
  }
}

.control.is-invalid {
  .multiselect {
    .multiselect__tags {
      border: 2px #EB0600 solid;
    }
  }
}
.multiselect.is-invalid {
  .multiselect__tags {
    border: 2px #EB0600 solid;
  }
}
.multiselect.is-valid {
  .multiselect__tags {
    border: 2px #078b40 solid;
  }
}

.multiselect__placeholder {
  color: #838383;
  margin-bottom: 0px;
  padding-top: 0;
}

.multiselect__single, .multiselect__tags, .multiselect__content, .multiselect__option {
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  max-width: 100%;
}

.multiselect__option--highlight {
  background-color: @blue;
}

.multiselect__option--selected.multiselect__option--highlight {
  background-color: @blue;
}

.filter-dropdown {
  .multiselect__tags {
    border: none;
  }
  .multiselect__placeholder{
    color: #838383;
    font-size: 0.8em;
  }
  .multiselect__option {
    font-size: 0.8em;
  }

  .multiselect__single {
    font-size: 0.9em;
  }
}
.actions {
  .multiselect__tags {
    border: 2px solid #6c757d !important;
  }
  .multiselect__placeholder{
    color: #838383;
    font-size: 1em;
    margin-bottom: 8px;
    padding-top: 0;
  }
  .multiselect__option {
    font-size: 0.9em;
  }

  .multiselect__single {
    font-size: 1em;
  }
}

.search-usergroups {
  .multiselect__select {
    z-index: 1 !important;
  }
  .multiselect__clear {
    position: absolute;
    right: 1px;
    top: 3px;
    width: 40px;
    display: block;
    cursor: pointer;
    z-index: 9;
    background-color: #fff;
  }
  .multiselect__spinner {
    z-index: 2 !important;
    background-color: #fff;
    opacity: 1;
    top: 2px;
  }
}

.ftp-choices {
  .multiselect__single, .multiselect__tags {
    white-space: normal !important;
    .multiselect__tag {
      background: @blue;
      .multiselect__tag-icon::after {
        color: white;
      }
      .multiselect__tag-icon:hover {
        background: rgba(255, 0, 0, 0.692);
      }
    }
  }
}

#services-nav-dropdown {
  font-weight: 600;
  .nav-link-custom {
    color: rgba(255, 255, 255, 0.75) !important;
  }
  .nav-link-custom:hover {
    color: #ffffff !important;
  }
  .nav-link-custom::after {
    border: none;
  }
  a:active, a:focus {
    outline: 0;
    border: none;
  }
}
#services-nav-dropdown.show {
  .nav-link-custom {
    color: rgba(255, 255, 255) !important;
  }
  .dropdown-menu.show {
    box-shadow: 0px 2px 10px 0px #aaa;
    border-top-color: transparent;
    background-color: @blue;
    border: none;
    border-radius: 3px;
    z-index: 1;
    padding: 0;
    text-shadow: 0 0 1px #ffffff;
    .dropdown-item {
      padding: 0.5rem 1rem;
      color: white;
    }
    .dropdown-item:hover {
      background-color: @blue !important;
      color: white;
      font-weight: bold;
    }
  }
}

// Toasts
#toast-container {
  top: calc(@headerHeight + 5px);
  width: inherit;
  div {
    opacity: 1;
  }
}
.toast {
  max-width: 100%;
  font-size: 1rem;
}
.toast:hover {
  box-shadow: 0 0 12px #000000b3;
}
.toast-success {
  background-color: #198754;
  .toast-progress {
    background-color: rgb(224, 224, 224);
    height: 2px;
  }
}
.toast-error {
  background-color: #dc3545;
}
